%  silhuetter
clear 
InitiateMDL;

load profil_all2

for profil = 1:22,
    lengde(profil) = min(find(profiler(profil,:)==0))-1;	
end


figure(55)

for profil = 1:22,
    prof_y = fix((profil-1)/11);
    prof_x = profil-prof_y*11;
    js_subplot(1/11*(prof_x-1),0.5*(1-prof_y),1/14,0.45); 
    plot(profiler(profil,1:lengde(profil)),1:lengde(profil),'b');
    hold on;
    axis ij
    axis equal
    axis off
    title(int2str(profil))
end
hold off;

max_lengde = max(lengde);
profiler = profiler(:,1:max_lengde);	% Smider overskyende 0'er vk
C = zeros(22,max_lengde);
Cn = lengde;
for profil = 1:22,
	len = lengde(profil);
	C(profil,1:len) = profiler(profil,1:len) - j*(1:len); % x+jy
	if len < max_lengde,	
        % Kopierer sidste punkt til resten af vektoren 
		C(profil,len+1:end) = C(profil,len);
	end
end

% figure(11);plot(C(:,:).','-');axis equal;

studyName='Silhouettes';

ends = 2;
P = 64;
ps = [32 64 65   16 48   8 24 40 56  12 20 28   44 52  42 46 50 54]; 
Astart = 0.12;
Aend = 0.07;

mode = 2;
sigmaCut = 0.003;
curvFac = 0.0150;
curvSmear = 1.5;
curvSkip = 5;

nPasses = 4;
Run;
save goodSilInter;
% 
 stepsizes = ones(size(stepsizes)) * 0.01; 
 curvFac = 150;
% 
nPasses = 6;
RunExtra;
save goodSil15;

% running with 
% curvSmear = 0.8;
% was tried - it is not better

%    If you run these, you'll keep the good solution
% i.e. the curvature cost acts as catalyst for escaping local minima 
% nPasses = 2;
% stepsizes = ones(size(stepsizes)) * 0.01; 
% curvFac = 0.015;
% RunExtra;
% save goodSilExtra;


