function [C, Cn] = FormFemur
 
% Constructs 32 contours of proximal femur in supine X-ray projection
% The contours are organised as the complex rows of C
% Each contour is described by a variable number of points, 
% The contours are stored in a [s,res+1] matrix
% Cn of size [s] is the number of points that describe each contour.
%   the rest of the entries up to res+1 are set to the end point
% res is displayed during runtime

load femur32;
C = Cnew;
Cn = Cnewn;
disp(max(Cn));
