% BoxBump script

clear
InitiateMDL;

studyName='BoxBump';
[C, Cn] = FormBoxBump(0.0, 0.2, 0.7);

ends = 1;  % closed curve
P = 64;
ps = [32 64  16 48  8 24 40 56]; % 64 is the same as 0
useMasterNodeValues = 1;
MasterNodeValues = [1 2 3 4 5 6 7 25 26];
initAll = 0;

mode = 1;
sigmaCut = 0.003;

nPasses = 40;
Run;

% save node parameters before next run

ASave = AHisTot;

% Do another run, but now with all examples initiated to the tru locations

initAll = 1;
Run;
ARepro = ASave - AHisTot;

figure(15)
ahis = size(ARepro,2)-1;
scales = [1 1 0.5 0.5 0.25 0.25 0.25 0.25];
for node=1:nps
    subplot(2,4,node);
    plot(0:ahis, ARepro(:,:,node)'*scales(node));
    ylabel('Node parameter difference');
    xlabel('Step number');
    ylim([-0.04, 0.04]);
    title(studyName);
end




